--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      LSW CORE LIB: CRYPTO
-- @author    Valentin Schmidt
-- @version   0.2
-- @requires  xtra("Crypto")
--****************************************************************************

property ancestor
property $

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

  $.loadXtras(me.libdir, ["Crypto.x32"], ["CryptoXtra.xtra"])
  --put xtra("Crypto").interface()
  
  me.ancestor = xtra("Crypto").new()
    
  -- optional: import lib with 2 global functions
  $.include(me.libdir&"crypto.lib.ls")
  
  return me
end
