--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*int)
on new (me,p1)
  me._class = #Printer
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class,VOID,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Printer
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- newPage ()
on newPage (me)
  $.Qt._qx.callObject(me._id,#newPage)
end

-- printerName () -> string
on printerName (me)
  return $.Qt._qx.callObject(me._id,#printerName)
end

-- setColorMode (int)
on setColorMode (me,p1)
  $.Qt._qx.callObject(me._id,#setColorMode,p1)
end

-- setFullPage (bool)
on setFullPage (me,p1)
  $.Qt._qx.callObject(me._id,#setFullPage,p1)
end

-- setOrientation (int)
on setOrientation (me,p1)
  $.Qt._qx.callObject(me._id,#setOrientation,p1)
end

-- setOutputFileName (string)
on setOutputFileName (me,p1)
  $.Qt._qx.callObject(me._id,#setOutputFileName,p1)
end

-- setOutputFormat (int)
on setOutputFormat (me,p1)
  $.Qt._qx.callObject(me._id,#setOutputFormat,p1)
end

-- setPageMargins (float,float,float,float,int)
on setPageMargins (me,p1,p2,p3,p4,p5)
  $.Qt._qx.callObject(me._id,#setPageMargins,p1,p2,p3,p4,p5)
end

-- setPaperSize (int)+(float,float,int)
on setPaperSize (me,p1)
  $.Qt._qx.callObject(me._id,#setPaperSize,p1)
end

-- setPrinterName (string)
on setPrinterName (me,p1)
  $.Qt._qx.callObject(me._id,#setPrinterName,p1)
end

-- setPrintRange (int)
on setPrintRange (me,p1)
  $.Qt._qx.callObject(me._id,#setPrintRange,p1)
end

-- setResolution (int)
on setResolution (me,p1)
  $.Qt._qx.callObject(me._id,#setResolution,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------
