--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1,p2)
  me._class = #SciLexer
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1,p2)
  return me
end

-- static
--on _make (scr, id)
--	obj = scr.rawNew()
--	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
--	obj._class = #SciLexer
--	obj._id = id
--	return obj
--end


----------------------------------------
-- ACTIONS
----------------------------------------

-- readSettings (string iniFile) -> bool
on readSettings (me,p1)
  return $.Qt._qx.callObject(me._id,#readSettings,p1)
end

-- setColor (color, *int style)
on setColor (me,p1,p2)
	if integerP(p2) then $.Qt._qx.callObject(me._id,#setColor,p1,p2)
	else $.Qt._qx.callObject(me._id,#setColor,p1)
end

-- setDefaultColor (color)	
on setDefaultColor (me,p1)
	$.Qt._qx.callObject(me._id,#setDefaultColor,p1)
end

-- setDefaultFont (int fontID)
on setDefaultFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callObject(me._id,#setDefaultFont,p1)
end

-- setDefaultPaper (color)
on setDefaultPaper (me,p1)
	$.Qt._qx.callObject(me._id,#setDefaultPaper,p1)
end

-- setFont (FontID, *int style)
on setFont (me,p1,p2)
  if ilk(p1)=#instance then p1 = p1._id
	if integerP(p2) then $.Qt._qx.callObject(me._id,#setFont,p1,p2)
  else $.Qt._qx.callObject(me._id,#setFont,p1)
end

-- setPaper (color, *int style)
on setPaper (me,p1,p2)
	if integerP(p2) then $.Qt._qx.callObject(me._id,#setPaper,p1,p2)
	else $.Qt._qx.callObject(me._id,#setPaper,p1)
end

-- writeSettings (string iniFile) -> bool
on writeSettings (me,p1)
  return $.Qt._qx.callObject(me._id,#writeSettings,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------
