--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (string,*bool,int)
on new (me,p1,p2,p3)
  me._class = #ToolTip
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class,VOID,p1,p2,p3)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #ToolTip
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

----------------------------------------
-- STATIC
----------------------------------------

-- hideText ()
on hideText (scr)
  $.Qt._qx.callObject(#ToolTip,#hideText)
end

-- showText (point pos, string msg)
on showText (scr,p1,p2)
  $.Qt._qx.callObject(#ToolTip,#showText,p1,p2)
end

----------------------------------------
-- SIGNALS
----------------------------------------
